# Configuration file for the Sphinx documentation builder.
#
# This file only contains a selection of the most common options. For a full
# list see the documentation:
# http://www.sphinx-doc.org/en/master/config

# -- Path setup --------------------------------------------------------------

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
#
# import os
# import sys
# sys.path.insert(0, os.path.abspath('.'))

import sphinx_rtd_theme
# from recommonmark.transform import AutoStructify

# -- Project information -----------------------------------------------------

project = 'Autolabor Box'
copyright = '2019, Autolabor'
author = 'yangdr'

# -- General configuration ---------------------------------------------------

# Add any Sphinx extension module names here, as strings. They can be
# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
# ones.
extensions = [
    'recommonmark',
    'sphinx_markdown_tables'
]

source_suffix = {
    '.rst': 'restructuredtext',
    '.md': 'markdown'
}

# def setup(app):
#     app.add_config_value(
#         'recommonmark_config',
#         {
#             'enable_eval_rst': True,
#             'enable_auto_doc_ref': True,
#         },
#         True)
#     app.add_transform(AutoStructify)

# Add any paths that contain templates here, relative to this directory.
templates_path = ['page_templates']

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#
# This is also used if you do content translation via gettext catalogs.
# Usually you set "language" from the command line for these cases.
language = 'zh_CN'

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
# This pattern also affects html_static_path and html_extra_path.
exclude_patterns = []

# -- Options for HTML output -------------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
#
html_theme = 'sphinx_rtd_theme'
html_context = {
    'display_github': True,
    'github_user': 'autolaborcenter',
    'github_repo': 'pm1-docs-sphinx',
    'github_version': 'master/source/'
}

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
html_static_path = ['_static']

html_context = {
    'css_files': ['_static/css/page.css']
}

# import recommonmark
# from recommonmark.transform import AutoStructify

# github_doc_root = 'https://github.com/rtfd/recommonmark/tree/master/doc/'
# def setup(app):
#     app.add_config_value(
#         'recommonmark_config',
#         { 'enable_auto_toc_tree': True },
#         True
#     )
#     app.add_transform(AutoStructify)
